"
 COPYRIGHT (c) 2006 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libtool' }"

"{ NameSpace: Tools }"

Object subclass:#ProfilerInfoBuilder
	instanceVariableNames:'packages percentageCutOff'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Browsers-New-Profiler'
!

ProfilerInfoBuilder subclass:#MethodList
	instanceVariableNames:'methodsToInfoItems'
	classVariableNames:''
	poolDictionaries:''
	privateIn:ProfilerInfoBuilder
!

!ProfilerInfoBuilder class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!ProfilerInfoBuilder class methodsFor:'instance creation'!

new
    ^ self basicNew initialize.

    "Created: / 01-12-2007 / 22:46:19 / janfrog"
! !

!ProfilerInfoBuilder methodsFor:'accessing'!

items

    ^self subclassResponsibility

    "Created: / 01-12-2007 / 23:40:07 / janfrog"
!

packages
    ^ packages

    "Created: / 01-12-2007 / 22:45:27 / janfrog"
!

packages:something
    packages := something.

    "Created: / 01-12-2007 / 22:45:27 / janfrog"
!

percentageCutOff
    ^ percentageCutOff ? 0

    "Created: / 01-12-2007 / 22:45:27 / janfrog"
!

percentageCutOff:something
    percentageCutOff := something.

    "Created: / 01-12-2007 / 22:45:27 / janfrog"
! !

!ProfilerInfoBuilder methodsFor:'initialization'!

initialize
    "Invoked when a new instance is created."

    "/ please change as required (and remove this comment)
    "/ packages := nil.
    "/ percentageCutOff := nil.

    "/ super initialize.   -- commented since inherited method does nothing

    "Created: / 01-12-2007 / 22:46:19 / janfrog"
! !

!ProfilerInfoBuilder methodsFor:'testing'!

isFiltered: profileTree

    profileTree totalTally < self percentageCutOff ifTrue:[^true].
    packages ifNil:[^false].
    ^(packages includes: profileTree package) not

    "Created: / 01-12-2007 / 22:56:49 / janfrog"
! !

!ProfilerInfoBuilder::MethodList class methodsFor:'documentation'!

version
    ^'$Id: Tools__ProfilerInfoBuilder.st,v 1.1 2011-07-01 13:27:40 cg Exp $'
! !

!ProfilerInfoBuilder::MethodList methodsFor:'accessing'!

items

    ^methodsToInfoItems values asSortedCollection:
        [:a :b|a tally > b tally]

    "Created: / 01-12-2007 / 23:40:34 / janfrog"
! !

!ProfilerInfoBuilder::MethodList methodsFor:'building'!

build: profileTree

    (self isFiltered: profileTree) ifFalse:
        [(self itemForMethod: profileTree method) tallyAdd: profileTree leafTally].
    profileTree called ifNotNil:
        [profileTree called do:[:e|self build:e]]

    "Created: / 01-12-2007 / 22:49:55 / janfrog"
! !

!ProfilerInfoBuilder::MethodList methodsFor:'initialization'!

initialize

    super initialize.
    methodsToInfoItems := Dictionary new

    "Modified: / 01-12-2007 / 22:48:43 / janfrog"
! !

!ProfilerInfoBuilder::MethodList methodsFor:'private'!

itemForMethod: method

    ^methodsToInfoItems 
        at: method 
        ifAbsentPut:[ProfilerInfoItem new method: method]

    "Created: / 01-12-2007 / 22:52:35 / janfrog"
! !

!ProfilerInfoBuilder class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libtool/Tools__ProfilerInfoBuilder.st,v 1.1 2011-07-01 13:27:40 cg Exp $'
!

version_SVN
    ^ 'Id: Tools__ProfilerInfoBuilder.st 7486 2009-10-26 22:06:24Z vranyj1 '
! !
